// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "TicTacToeTile.hpp"
#include "scene/SceneItem.hpp"

using namespace Dawn;

TicTacToeTile::TicTacToeTile(SceneItem *item) : SceneItemComponent(item) {
}

void TicTacToeTile::onStart() {
  tileState = useState(TIC_TAC_TOE_EMPTY);
  hovered = useState(false);

  auto cb = [&]{
    auto sprite = this->item->getComponent<TiledSprite>();
    if(this->hovered) {
      sprite->setTile(0x03);
    } else {
      sprite->setTile(tileState);
    }
  };

  useEffect(tileState, cb);
  useEffect(hovered, cb);
  cb();
}